<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Jinja</title>

    <link rel="stylesheet" href="/en/latestcss/core.css">
    <link rel="stylesheet" href="/en/latestcss/getstarted.css">
    <link rel="shortcut icon" href="/en/latestcss/images/saltStack_favIcon_32x32.png">

</head>
<body>

<nav id="globalNavbar" class="navbar navbar-default navbar-inverse navbar-fixed-top" role="navigation">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="http://saltstack.com/" target="_blank"><img src="/en/latestcss/images/saltstack.svg" height="40px" width="170px" class="nolightbox"></a>
        </div>
        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                <li><a href="/en/latest">Documentation</a></li>
                <li><a href="/en/getstarted/">Tutorials</a></li>
                <li><a href="/en/latestcontents.html">Reference Guide</a></li>
                <li><a href="https://repo.saltstack.com">Downloads</a></li>
                <li><a href="/en/latesttopics/development/">Develop</a></li>
            </ul>
        </div>
    </div>
</nav>

<div class="jumbotron">

    <div class="row row-centered">
        <div class="col-md-9 col-centered">
            <h1>SaltStack Configuration Management</h1>

            <h3>Get Started Tutorial</h3>

        </div>
    </div>
    <!--<div class="gs-top-nav">
        <a href="/en/getstarted/getstarted/index.html">Back to Get Started <i class="glyphicon glyphicon-arrow-left"></i></a><br>
        <a href="/en/getstarted">Back to Documentation <i class="glyphicon glyphicon-arrow-left"></i></a>
    </div>-->
</div>







<div class="container">
    <div class="row">
        <div class="col-md-12">
            <ol class="progtrckr" data-progtrckr-steps="7">
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/index.html">Introduction</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/functions.html">Functions</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/pillar.html">Pillar</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/include.html">Includes</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/requisites.html">Ordering & Requisites</a>
                </li>
                
                
                
                <li class="progtrckr-done">Jinja</li>
                
                
                
                
                
                
                
                
                
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/config/files.html">Manage Files</a>
                </li>
                
                
            </ol>
        </div>
    </div>

    <div class="row">
        <div class="col-md-1"></div>
        <div class="col-md-10">

            

            <h1>Jinja</h1>

            <div class="section gs-overview">

                
                <p class="p gs-overview-sub"><span class="ph">You'll learn how to:</span></p>

                <ul class="ul">
                    
                    <li class="progtrckr-done">Use Jinja conditionals</li>
                    
                    <li class="progtrckr-done">Use Jinja loops</li>
                    
                    <li class="progtrckr-done">Call salt execution modules using Jinja</li>
                    
                </ul>
                

                
                <p class="p gs-overview-sub gs-time"><span class="ph">
                              Estimated time: 15 minutes</span>&nbsp;<i
                        class="glyphicon glyphicon-time"></i>
                </p>
                

                
                <p class="p gs-overview-sub gs-difficulty-1"><span class="ph">Difficulty</span>:&nbsp;
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                </p>
                
            </div>
            

            <div class="section sidebar">
<h4 id="more-jinja2">More Jinja2</h4>
<p>Jinja2 is widely used, and there is a lot more detail in the <a href="http://jinja.pocoo.org/docs/dev/">Jinja2 docs</a>.</p>
</div>
<p>Salt includes the Jinja2 templating engine which can be used in Salt state files, Salt pillar files, and other files managed by Salt.</p>
<p>Salt lets you use Jinja to access minion configuration values, grains and Salt pillar data, and call Salt execution modules. This is in additional to the standard control structures and Python data types that are already available in Jinja.</p>
<h2 id="conditionals">Conditionals</h2>
<p>One of the most common uses of Jinja is to insert conditional statements into Salt pillar files.</p>
<p>Because many distros have different package names, you can use the <code>os</code> grain to set platform specific paths, package names, and other values.</p>
<p>For example:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="kw">{</span>% if grains[&#39;os_family&#39;] == &#39;RedHat&#39; %<span class="kw">}</span>
<span class="fu">apache:</span> httpd
<span class="fu">git:</span> git
<span class="kw">{</span>% elif grains[&#39;os_family&#39;] == &#39;Debian&#39; %<span class="kw">}</span>
<span class="fu">apache:</span> apache2
<span class="fu">git:</span> git-core
<span class="kw">{</span>% endif %<span class="kw">}</span></code></pre>
<p>As you can see, Salt grains are available in a dictionary much like Salt pillar. This example checks Salt grain values to set OS specific Salt pillar keys.</p>
<p>Save the snippet above to the saltstack/pillar/common.sls file, and then run the following commands to refresh and then list Salt pillar values for each minions:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt</span> <span class="st">&#39;*&#39;</span> saltutil.refresh_pillar
<span class="kw">salt</span> <span class="st">&#39;*&#39;</span> pillar.items</code></pre>
<p>Your minions should list the values set for the <code>Debian</code> OS family.</p>
<p>After setting these values, when you apply the following Salt state:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">install apache:</span>
  <span class="fu">pkg.installed:</span>
    <span class="kw">-</span> <span class="fu">name:</span> <span class="kw">{</span>{ pillar[&#39;apache&#39;] <span class="kw">}</span>}</code></pre>
<p>The <code>httpd</code> package is installed on RedHat, while the <code>apache2</code> package is installed on Debian.</p>
<h2 id="loops">Loops</h2>
<p>Loops are useful for creating users and folders in Salt states.</p>
<pre class="language-yaml"><code class="language-yaml"><span class="kw">{</span>% for usr in [&#39;moe&#39;,&#39;larry&#39;,&#39;curly&#39;] %<span class="kw">}</span>
<span class="kw">{</span><span class="fu">{ usr }}:</span>
  user.present
{% endfor %<span class="kw">}</span></code></pre>
<pre class="language-yaml"><code class="language-yaml"><span class="kw">{</span>% for DIR in [&#39;/dir1&#39;,&#39;/dir2&#39;,&#39;/dir3&#39;] %<span class="kw">}</span>
<span class="kw">{</span><span class="fu">{ DIR }}:</span>
  <span class="fu">file.directory:</span>
    - <span class="fu">user:</span> root
    - group: root
    - mode: 774
{% endfor %<span class="kw">}</span></code></pre>
<p>In general, you should try to keep your Salt states as simple as possible. If you find yourself writing complex Jinja, you should consider breaking a task into multiple Salt states, or writing a custom Salt <a href="https://docs.saltstack.com/en/latest/ref/modules/index.html#modules-are-easy-to-write">execution module</a> for the task (this is easier than it sounds, especially if you know some Python!).</p>
<h2 id="get-data-using-salt">Get Data using Salt</h2>
<p>You can call Salt execution functions from Jinja to get real-time data from the system.</p>
<pre class="language-yaml"><code class="language-yaml"><span class="kw">{</span>{ salt.cmd.run(&#39;whoami&#39;) <span class="kw">}</span>}</code></pre>


            <br>
            
            <a href="/en/getstarted/config/requisites.html">
                <button type="button" class="btn btn-secondary"><span
                        class="glyphicon glyphicon-chevron-left"></span> Previous
                </button>
            </a>
            

            
            <a href="/en/getstarted/config/files.html">
                <button type="button" class="btn btn-primary btn-right">
                    Next <span class="glyphicon glyphicon-chevron-right"></span></button>
            </a>
            

        </div>
        <div class="col-md-1"></div>
    </div>
    <div class="footer">
    <p>© 2020 SaltStack | <a href="http://saltstack.com/privacy-policy" target="_blank">Privacy Policy</a></p>
</div>
</div>

<script type="text/javascript" src="/en/latestjs/core-min.js"></script>



<!--analytics-->
<script type="text/javascript" language="javascript">llactid=23943</script>
<script type="text/javascript" language="javascript" src="https://trackalyzer.com/trackalyze_secure.js"></script>

<script>
          var _gaq = _gaq || [];
          var pluginUrl = '//www.google-analytics.com/plugins/ga/inpage_linkid.js';
          _gaq.push(['_require', 'inpage_linkid', pluginUrl]);
          _gaq.push(['_setAccount', 'UA-26984928-1']);
          _gaq.push(['_setDomainName', 'saltstack.com']);
          _gaq.push(['_trackPageview']);

          (function() {
              var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
              ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
              var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();

</script>

</body>
</html>